<link rel="import" href="/extern/bower_components/polymer/polymer.html">

<link rel="import" href="/extern/bower_components/neon-animation/neon-animated-pages.html">
<link rel="import" href="/extern/bower_components/neon-animation/neon-animatable.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-left-animation.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-right-animation.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-from-left-animation.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-from-right-animation.html">

<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">
<link rel="import" href="/ts/common-elements/responsive-behavior/responsive-behavior.html">


<!--
`master-detail-layout` implements a responsive master-detail layout

When on a large enough screen, the master and detail view are displayed side to side.
When on a small device, either the master or the detail view is shown, and the user can switch between them

Example:

    <master-detail-layout>
      <div master>I am the master view</div>
      <div detail>I am the detail view</div>
    </master-detail-layout>

### Styling
The following custom properties and mixins are available for styling:

Custom property | Description | Default
----------------|-------------|----------
`--master-container-mixin` | Mixin for the container of the master view | `{}`
`--detail-container-mixin` | Mixin for the container of the detail view | `{}`
`--large-master-container-mixin` | Mixin for the container of the master view on large screens | `{}`
`--small-master-container-mixin` | Mixin for the container of the master view on small screens | `{}`
`--large-detail-container-mixin` | Mixin for the container of the detail view on large screens | `{}`
`--small-detail-container-mixin` | Mixin for the container of the detail view on small screens | `{}`
`--large-container-mixin` | Mixin for the container of the large view | `{}`
`--small-container-mixin` | Mixin for the container of the small view | `{}`

@demo demo/index.html


-->

<dom-module id="master-detail-layout">
    <template>
      <style include="reset-css"></style>
      <style include="iron-flex-layout-attributes"></style>
      <link rel="stylesheet" type="text/css" href="css/master-detail-layout-min.css?__inline=true">

      <div id=largecontainer horizontal layout>
        <neon-animatable id="mastercontainer">
          <content select="[[masterSelector]]"></content>
        </neon-animatable>
        <neon-animatable flex id="detailcontainer">
          <content select="[[detailSelector]]"></content>
        </neon-animatable>
      </div>
      <neon-animated-pages id=smallcontainer
                           selected={{smallSelected}}
                           entry-animation=[[entryanimation]]
                           exit-animation=[[exitanimation]]>
      </neon-animated-pages>
    </template>

    <script src="javascript/master-detail-layout-min.js?__inline=true"></script>
</dom-module>
